@use(App\Models\System)

@extends('layouts.app')

@section('htmlheader_title')
	Register System
@endsection

@section('content')
	<form class="needs-validation" method="post" autocomplete="off" novalidate>
		@csrf
		<input type="hidden" name="action" value="register">

		<div class="row">
			<div class="col-12">
				<div class="greyframe titledbox shadow0xb0">
					<h2 class="cap">Register System</h2>

					<div id="create">
						<div class="row">
							<!-- Name -->
							<div class="col-4">
								@php($options = System::select(['systems.id','systems.name'])
									->active()
									->where('id','<>',$setup->system_id)
									->whereRaw('id NOT IN (SELECT system_id FROM "system_user")')
									->cursor())

								<x-form.select name="system_id" icon="bi-laptop-fill" label="BBS Name" placeholder="See if your BBS exists, otherwise add it" feedback="BBS Name is required" helper="Enter your BBS name and press NEXT" :addvalues="true" :options="$options->map(fn($item)=>['id'=>$item->id,'value'=>$item->name])" required/>
							</div>
						</div>

						<div class="row">
							<div class="col-12 pb-2">
								<button type="submit" class="btn btn-success">Next</button><span id="next" class="m-2"><i class="spinner-border spinner-border-sm text-light d-none"></i></span>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</form>
@endsection