<!-- $so=System::class -->
@use(App\Models\System)

@extends('layouts.app')

@section('htmlheader_title')
	Register System
@endsection

@section('content')
	@if(! $so->address)
		<h3 class="pt-2">Enable to complete registration</h3>

		<p>The system you selected <strong class="highlight">{{ $so->name }}</strong> doesnt have mailer details, please contact that system administration to update those details first</p>
	@else
		<h3 class="pt-2">System Details:</h3>
		<table class="monotable">
			<tr>
				<th>System</th>
				<th>{{ $so->name }}</th>
			</tr>
			<tr>
				<th>Sysop</th>
				<th>{{ $so->sysop }}</th>
			</tr>
			<tr>
				<th>Location</th>
				<th>{{ $so->location }}</th>
			</tr>
			<tr>
				<th>Networks</th>
				<th>{{ $so->akas->pluck('ftn')->join(', ') }}</th>
			</tr>
			<tr>
				<th>Address</th>
				<th>{{ $so->access_mailer }}</th>
			</tr>
		</table>

		<p>If the details are above are not correct, then please contact the (ZC) to have them corrected first.</p>

		<p>Otherwise, if all is good, we'll send a netmail to <strong class="highlight">{{ $so->sysop }}</strong> at <strong class="highlight">{{ $so->access_mailer }}</strong></p> with further details.

		<form class="needs-validation" method="post" autocomplete="off" action="{{ url('user/system/link') }}" novalidate>
			@csrf

			<input type="hidden" name="system_id" value="{{ $so->id }}">
			<input type="hidden" name="name" value="{{ $so->name }}">

			<div class="row pb-2">
				<div class="col-12">
					<input type="submit" name="action" class="btn btn-success" value="Link">
				</div>
			</div>
		</form>
	@endif
@endsection